
'-----------------------------    Ramin chamanara   ----------------------------
'-----------------------  Ramin.Chamanara.Marzikola@Gmail.com  -----------------

'---------------------------    micro config    --------------------------------

$regfile = "m32def.dat"

'----------------------------   crystal config   -------------------------------

$crystal = 1000000                                          'internal crystal
'$crystal = 11059200                                         'external crystal
'$crystal = 16000000
'-----------------------------  baud rate  -------------------------------------

$baud = 9600                                                'speed of send,recive
                                                            ' between avr ,pc
'----------------------------   config lcd   -----------------------------------

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , Rs = Portb.0 , E = Portb.2

'--------------------------   config ADC   -------------------------------------

Config Adc = Single , Prescaler = Auto , Reference = Avcc   'Internal
Start Adc
Enable Interrupts

'-------------------  config output,input ports  -------------------------------

'Config Portd = output
Config Pina.0 = Input
Config Pina.1 = Input
Config Pina.2 = Input
Config Pina.3 = Input
Config Pina.4 = Input
Config Pina.5 = Input
Config Pina.6 = Input
Config Pina.7 = Input
'Config Pinc.5 = Input

Config Pind.2 = Output
Config Pind.3 = Output
Config Pind.4 = Output
Config Pind.5 = Output
Config Pind.6 = Output
Config Pind.7 = Output

'---------------------    config number of digits  -----------------------------
 Config Single = Scientific , Digits = 1

 '--------------------  config timer 1 for smt160  -----------------------------

Config Timer1 = Timer , Prescale = 1
Enable Timer1

'-------------------------------- lcd Twinkle '---------------------------------
Cursor Off

'---------------------  config variant and constant  ---------------------------

'Seting Alias Pinc.2
 'Up Alias Pinc.3
  'Down Alias Pinc.4
   'Menu Alias Pinc.5
    Dim T As Word
     Dim Count As Word
      Dim Temp1 As Single
       Dim Temp2 As Single
        'Dim Temp3 As Single
         Dim Newtemp1 As Single
          Dim Newtemp2 As Single
           'Dim Newtemp3 As Single
            Dim Lasttemp1 As Single
             Dim Lasttemp2 As Single
              'Dim Lasttemp3 As Single
               Dim Pwm1_reset As Word
                Dim Pwm1_set As Word
                 Dim Duty1 As Single
                  Dim X1 As Integer
                   'Dim Pwm2_reset As Word
                    'Dim Pwm2_set As Word
                    ' Dim Duty2 As Single
                      'Dim X2 As Integer
                       Dim A As Word
                        Dim B As Single
                         Dim C As Word
                          Dim D As Single
                           Dim E As Word
                            Dim F As Single
                             Dim G As Word
                             'Dim Average As Single
                               Dim Setpoint As Single
                                Dim Sp_decimal As Single
                                 Dim N1 As Word
                                  Dim N2 As Word
N1 = 0
N2 = 0
Setpoint = 25
Sp_decimal = 5
Newtemp1 = 0
Newtemp2 = 0
'Newtemp3 = 0
Count = 0                                                   'shomaresh
'--------------------------     wellcome      ----------------------------------
Locate 1 , 1
Lcd "Hello "

Locate 2 , 1
Lcd "ramin chamanara"

Waitms 800
Cls
'-------------------------------------------------------------------------------
 'Declare Sub Tempsens_lm35
 'Declare Sub Tempsens_smt160_1
 'Declare Sub Tempsens_smt160_2
 'Declare Sub Calculations
 'Declare Sub Key
 'Declare Sub Lcdgreen
 'Declare Sub Chek
 'Declare Sub Sendto_computer
 'Declare Sub Recive_from_computer
 Cursor Off
'---------------------------  summon function  ---------------------------------

Do
'Call Chek
 Gosub Tempsens_lm35
 Gosub Tempsens_smt160
 'Gosub Tempsens_smt160_2
 Gosub Calculations
'gosub Key
 Gosub Lcdgreen
 Gosub Sendto_computer
 Gosub Recive_from_computer
 Gosub Control_output
 Gosub Get_setpoint
Loop

End

'===============================  Sub Chek =====================================
'Sub Chek
'-------------------------------------------------------------------------------
'============================  Sub Tempsens(lm35)  =============================

Tempsens_lm35:
'-------------------------------------------------------------------------------

T = Getadc(0)
Temp1 = T / 1.8581                                          '1.9  '2

Return

'======================  Sub Tempsens(smt160(1))   =============================
Tempsens_smt160:
'-------------------------------------------------------------------------------

Bitwait Pina.1 , Set
Bitwait Pina.1 , Reset
Bitwait Pina.1 , Set
Bitwait Pina.1 , Reset
Bitwait Pina.1 , Set
Bitwait Pina.1 , Reset
Stop Timer1


Bitwait Pina.1 , Set
Timer1 = 0
Start Timer1
Bitwait Pina.1 , Reset

Pwm1_set = Timer1


Timer1 = 0
Start Timer1
Bitwait Pina.1 , Set

 Pwm1_reset = Timer1

X1 = Pwm1_set + Pwm1_reset
Duty1 = Pwm1_set / X1

Duty1 = Duty1 - 0.32
'Waitms 1
Temp2 = Duty1 / 0.0047
'Waitms 1
Locate 1 , 1

Stop Timer1
Timer1 = 0
Return


'====================   Declare Sub Calculations   =============================
Calculations:
'-------------------------------------------------------------------------------

Newtemp1 = Temp1 + Newtemp1
Newtemp2 = Temp2 + Newtemp2
Count = Count + 1
If Count = 60 Then

Lasttemp1 = Newtemp1 / 60
Lasttemp2 = Newtemp2 / 60

Newtemp1 = 0
Newtemp2 = 0

End If



Return

'=============================  Sub Lcdgreen  ==================================
Lcdgreen:
'-------------------------------------------------------------------------------
If Count = 60 Then

Cls
Home
Lcd "LabView 2011"
'Lcd "lm35 =     "                                           'Config Single = Scientific , Digits = 1
Locate 2 , 2
Lcd Lasttemp1 ; " c'";
                             'Config Single = Scientific , Digits = 2
'Locate 2 , 1
'Lcd "smt160 =   "
Locate 2 , 9
Lcd Lasttemp2 ; " c'";

Waitms 100

End If

Return

'=========================  Sub Sendto Computer   ==============================

Sendto_computer:
'-----------------------------  send temp1 (lm35) ------------------------------
If Count = 60 Then

Count = 0
Newtemp1 = 0
Newtemp2 = 0

A = Fix(lasttemp1)
B = Lasttemp1 - A
B = B * 10
A = A + 10000
B = B + 20000
B = Round(b)

Print A
'Waitms 1
Print B
'Waitms 1

'-----------------------------  send temp2 (smt160) --------------------------
C = Fix(lasttemp2)
D = Lasttemp2 - C
D = D * 10
C = C + 30000
D = D + 40000
D = Round(d)

Print C
'Waitms 1
Print D
'Waitms 1
End If
Return
'===================   Sub Recive From Computer   ==============================

Recive_from_computer:

G = Inkey()
Return
'--------------------------   Gosub Control_output   ---------------------------
Control_output:

Debounce Pina.4 , 1 , Automatic
Debounce Pina.4 , 0 , Computer
Return
'------------------------      order to output     -----------------------------

'***********
          '*
Computer:
          '*
'***********
'N2 = 0
'N1 = N1 + 1
'If N1 = 0 Then
'Reset Portd.2 : Reset Portd.3 : Reset Portd.4 : Reset Portd.5 : Reset Portd.6 : Reset Portd.7
'End If
        If G = 52 Then
         Portd = 8
          Elseif G = 53 Then
           Set Portd.4
            Elseif G = 54 Then
             Reset Portd.4
              Elseif G = 51 Then
        Portd = 0
        End If
'If N1 = 100 Then
'N1 = 1
'End If

Return
'***********
          '*
Automatic:
          '*
'***********
'N2 = N2 + 1
'N1 = 0
'If N2 = 0 Then
'Reset Portd.2 :Reset Portd.3 :Reset Portd.4 :Reset Portd.5 :Reset Portd.6 :Reset Portd.7
'End If
'If N2 = 100 Then
'N2 = 1
'End If
'------------------------------------------------------------------------------
'            Cls : Lcd Average
'               Locate 2 , 1 : Lcd Setpoint : Waitms 300
'------------------------------------------------------------------------------

  If Lasttemp2 < Setpoint Then
   Set Portd.5
    Elseif Lasttemp2 => Setpoint Then
     Reset Portd.5

End If
                                                'lm35
        If Lasttemp2 < 30 Then
         Set Portd.6
          Elseif Lasttemp2 => 30 Then
           Reset Portd.6

End If
Return

'--------------------------   Get_setpoint   -----------------------------------
Get_setpoint:


Debounce Pina.5 , 1 , Incrsp
Debounce Pina.7 , 1 , Decrsp

Return


Do
Incrsp:
If Pina.5 = 1 Then
Incr Sp_decimal
End If

Sp_decimal = Sp_decimal / 10
Setpoint = Setpoint + Sp_decimal
Cls
Home
Lcd "AVR Automatic"
Locate 2 , 6
Lcd Setpoint
Waitms 200
Cls
Debounce Pina.6 , 1 , Get_setpoint
Debounce Pina.7 , 1 , Decrsp
Loop




Do
Decrsp:
If Pina.7 = 1 Then
Decr Sp_decimal
End If
Sp_decimal = Sp_decimal / 10
Setpoint = Setpoint + Sp_decimal
Cls
Home
Lcd "AVR Automatic"
Locate 2 , 6
Lcd Setpoint
Waitms 200
Cls
Debounce Pina.6 , 1 , Get_setpoint
Debounce Pina.5 , 1 , Incrsp
Loop
